/*
 * CellAction.java
 *
 * Package Version: 4.0
 *   Class Version: 1.0
 *   
 * 		   Project: MEDLAND Project
 * 					Arizona State University
 * 
 * 			Author: Gary R. Mayer
 *   		  Date: 13 February 2008
 * 
 * This file contains the CellAction class which is used by the Interaction Model
 * (IM) to manage agent actions against land cells. It is specific to the domain
 * being modelled as it records the impact of the action on the cell.
 *  
 * Class Fixes / Additions:
 * 1.0:
 *  - None.
 * 
 * Bugs / Issues:
 * 1.0:
 *  - None.
 */

package PenaguilaALv4;

public class CellAction
{
	final String cell_coords;
	final String action_type;
	final double action_value;  // Double Impact Change
	
	/**
	 * CellAction - constructor
	 * @param coords (String) - land cell coordinates in [east],[north] format
	 * @param type (String) - the type of action to be taken on this cell
	 * @param value (int) - the value (impact) of the action against the cell
	 */
	public CellAction ( String coords, String type, int value )
	{
		this.cell_coords = coords;
		this.action_type = type;
		this.action_value = value;
		
	}
	
	public CellAction ( String coords, String type, double value ) // Double Impact Change
	{
		this.cell_coords = coords;
		this.action_type = type;
		this.action_value = value;
		
	}
}
