/*
 * InitParameters.java
 *
 * Created on December 20, 2007, 9:20 PM
 *
 */
/* ENABLE FOR DEVSJAVA */
package PenaguilaALv4;

import java.util.*;
/**/
public class InitParameters
{
	/***
	 * Manually Set Paths
	 */
	
	/*
		public String pythonloc = "/usr/bin/";
		public String gisbase = "/Applications/GRASS/GRASS-6.5.app/Contents/MacOS";
		public String user_path = "/Users/sbergin/Documents/Med_Sim_Files";
	*/
	
	/***
	 * These are modified by the GUI; manual changes may be overwritten.
	 */
	
	//NEW
	
	// WEIGHTS
	public double wooddistweight = 3; //   jTextFieldWoodDistanceWeight IP s
	public double gdistweight = 1; //  jTextFieldGrazingDistWight   IP s
	public double lcovweight = 1; // jTextFieldLcovDistWight   IP  s
	public double fdistweight = 1; // jTextFieldFarmDistWght   IP s
	public double sfertilweight = 1;// jTextFieldSoilFtyWight    IP s
	public double sdepthweight = 1; // jTextFieldDepthWght   IP s

	//CLIMATE
	public String climateDataPath = null; //"/Users/sbergin/Documents/APSIModel/climateData.csv"; //  jTextFieldClimFile 
	public boolean climateDataSeries = false; //  jComboBoxClimateSource 
	public double r_factor = 0; //5.66;
	public double annual_precip = 0; //0.5; worst name ever! change to annual precip and put in assesser     jTextFieldrainValue  IP
	public int storms = 75; // jTextFieldStormEvents  IP s
	public double storm_speed = 1.4; // jTextFieldStormSpeed  IP s
	public double storm_length = 6.0; // jTextFieldStormLength  IP s
	public double storm_precip = 10.0; // jTextFieldStormPrecip  IP s
	
	//WOOD GATHERING
	public double wood_pc =  0; //1662.98; //  jTextWoodPc //  no need to validate
	public double wood_intensity = 0; // 0.08; //  jTextFieldWoodIntensity,  
	
	//LANDSCAPE EVOL PARAMETERS
	public double soil_density = 0; //1.25;
	public String stream_transport = "0.001";
	public double load_exponent = 0; //1.5;
	public String evolSmoothing = "high"; // 
	public int kappa = 0; //1;
	public double cutoff1 =  0; //
	public double cutoff2 = 0; //
	public double cutoff3 = 0; //
	
	//OTHER LANDSCAPE PARAMETERS
	public double soil_depth_min = 0.5; //
	public double soil_depth_max = 7; //
	public int soil_recovery = 1; // 
	public int maxfarmcost = 10800; //  already existed   jTextMaxFarmDistance, new:   IP s
	public int maxgrazecost = 28800; // jTextMaxGrazeDistance            S              IP s
	public double degrade_rate = 3; // already existed   jTextFieldFertilityImpact    IP s 
	public int maxlcov = 50; // need to make sure this is an INT with teh GUI    jTextFieldMaxLcov    IP s 
	public double seed_percentage = 0.15; // jTextFieldSeedPct coming in as int      IP  s 
	
	//GRAZING PARAMETERS
	public double ovicaprid_per_person = 0; //4; 
	public int sheep_ratio = 0; //1;
	public int goat_ratio = 0; //1;
	public double ovicaprid_density = 0; //1; 
	public int sheep_fodder = 0; //= 584;			//kg average fodder requirement (Ullah 2008) // NEW
	public int goat_fodder = 0; //= 894;			//kg average fodder requirement (Ullah 2008) // NEW
	public double init_grazing_expectation = 0; //250; //   kg / fodder  for each ha 
	public double barley_fodder_percentage = 0; //10;// Does Go in as a whole number 
    public double pct_lactating_animals = 0; //0.6; //  jTextFieldPercentLactate 
    public double pct_meat_animals = 0; //0.25;  //   jTextFieldPercentMeat  
	public double sheep_return  = 0; //37625 ; //     jTextFieldSheepYield  
	public double goat_return = 0; //75400; //  jTextFieldGoatYield   
	public boolean fallow_field_grazing = true;
	
	//VILLAGE VARIABLES
    private int num_villages = 0;
    public ArrayList VData = null;
    public float agent_n = 1.0f;
    public float agent_s = 0.0f;
    public float agent_e = 1.0f;
    public float agent_w = 0.0f;

    //HOUSEHOLD PARAMETERS
    public int pct_clearing = 0;
    public double birth_init_prob = 0;
    public int birth_prob_group_size = 0;
    public double birth_prob_delta = 0;
    public int birth_prob_min = 0;
    public int birth_prob_max = 0;
    public double death_init_prob = 0; //
    public int death_prob_group_size = 0;
    public double death_prob_delta = 0;
    public int death_prob_min = 0;
    public int death_prob_max = 0;
    public int labor_pop_pct = 80;
    public int man_days_per_capita = 0;
    public int yield_expecation_scalar = 0;
    public double wheat_reqd_per_capita = 0;//  jTextWheatRqdPerPerson  
    public double meat_milk_calories_pc = 0 ;//250000.0;	//  jTextMeatMilkRqdPerPerson 
    
    //FARMING PARAMETERS
    public float wheat_labor_reqd = 0.0f;
    public float wheat_init_expected_yield = 0.0f;
    public double barley_labor_reqd = 0.0;  //  jTextBarleyLaborRqd 
    public double barley_init_expected_yield = 0.0;  //  jTextBarleyInitYield  
    public double wheat_calories_provided = 0; //03720; // this is good, usually entered as 3540 
    public double maximum_wheat_yield = 0 ;//3500; //  jTextFieldMaxWheatYield kg/ha 
    public double maximum_barley_yield = 0; //2500; // kg/ha 

    public String GISDBASE = null;
    public String location = null;
    public String mapset = null;
    public String DEM = null;
    public String bedrock_map = null;
    public String max_landcover_map = null;
    public String land_cover = null;
    public float friction_value = 0.0f;
    public String friction_map = null;
    public float soilK_value = 0.0f; // erosion resistivity value
    public String soilK_map = null;
    public String fertility_map = null; 
    public int date_start = 0;
    public int date_change_dir = 0;
    public int date_delta = 0;
    public int date_end = 0;
    public String date_prefix = null;
    public String date_suffix = null;
        
    // SYSTEM SETTINGS PARAMETERS
    public String APSIMPath = null;
    public String GrassPath = null;
    public String PythonPath = null;
	public boolean WorldWindDisplayOn = false;	
	public boolean HouseholdLogOn = false;	// Now shows all of the HH Info
	public boolean VillageLogOn = false;	
	public boolean IMLogOn = false;	 // save
	public boolean IMLogShow = false;
	public boolean popeconlogs  = true;
	public boolean KeepRasterMaps = false;
	
	public boolean landTenure = false;
	public boolean hhSizeLimit = false;
	public int hhSizeExtreme =  0 ;
	public int lcBreakPoint1 = 30;
	public int lcBreakPoint2 = 50;
	public int daBpoint1 = 25;
	public int daBpoint2 = 90;
	
	public String landcover_reclass_rules = null;
	public String landcover_color_rules = null;
	public String cfactor_reclass_rules = null;
	public String cfactor_color_rules = null;
	public String impacts_color_rules = null; // CAN BE REMOVED
	public String fertility_color_rules = null;
	public String grassrc6loc = null; 
    
    /** Creates a new instance of InitParameters */
    public InitParameters()
    {
    }
    
    public void AddVillage ( int id, String name, float ns, float ew, int clearing, int hh, int hh_pop )
    {
        VillageData vdata = new VillageData();
        vdata.vid = id;
        vdata.vname = name;
        vdata.vns = ns;
        vdata.vew = ew;
        vdata.vclearing = clearing;
        vdata.num_hh = hh;
        vdata.pop_per_hh = hh_pop;
        
        if ( VData == null )
//            VData = new java.util.ArrayList <VillageData> ();
          VData = new ArrayList();
        
        VData.add(vdata);
        num_villages = VData.size();
        
    }

    public double getBirth_init_prob() {
        return birth_init_prob;
    }
    
    public int NumVillages ()
    {
        return this.num_villages;
        
    }
    
    public class VillageData
    {
    	int vid = -1;
        String vname = null;
        float vns = 0.0f;
        float vew = 0.0f;
        int vclearing = 0;
        int num_hh = 0;
        int pop_per_hh = 0;
    }
    
}
