/*
 * CellData.java
 *
 * Package Version: 3.0
 *   Class Version: 1.0
 *   
 * 		   Project: MEDLAND Project
 * 					Arizona State University
 * 
 * 			Author: Gary R. Mayer
 *   		  Date: 28 June 2007
 * 
 * This file stores the landscape cell data sent by the interaction model (IM) to
 * an agent.
 * 
 * Note that cells are stored in GRASS east_north format.
 * 
 * Class Fixes / Additions:
 * 1.0:
 *  - None.
 * 
 * Bugs / Issues:
 * 1.0:
 *  - None.
 */

package PenaguilaALv4;

public final class LandData
{
	public final String land_coords;
	public final double soil_depth;
	public final double distance;
	public double land_cover;
	public double slope; // S*
	public int fertility; // S*
	public double land_value;
	public double wood_value;
	
	/**
	 * @param land_coords - coordinates of cell: east,north
	 * @param sdepth - soil depth
	 * @param dist - distance cost from village to cell
	 * @param type - a double value representing the current land cover
	 */
	public LandData ( String coords, double sdepth, double dist, double type , double sloap, int fertile) // double sloap
	{
		this.land_coords = coords;
		this.soil_depth = sdepth;
		this.distance = dist;
		this.land_cover = type;
		this.land_value = 0.0;
		this.wood_value = 0.0;
		this.slope = sloap;
		this.fertility = fertile;
		
	}
	
}
