/*
 * Messages.java
 *
 * Package Version: 3.0
 *   Class Version: 1.0
 *   
 * 		   Project: MEDLAND Project
 * 					Arizona State University
 * 
 * 			Author: Gary R. Mayer
 *   		  Date: 28 June 2007
 * 
 * This class provides an enumeration for all message types used in the simulation. 
 * 
 * NOTE: This implementation is NOT remote method invocation (RMI) safe
 * 	nor will it work if different objects are created using multiple jar files.
 * 
 * Class Fixes / Additions:
 * 1.0:
 *  - None.
 * 
 * Bugs / Issues:
 * 1.0:
 *  - None.
 */

package PenaguilaALv4;

public final class Messages
{
	/////////////////////////////////////
	//          MESSAGE TYPES          //
	/////////////////////////////////////
	public static final Messages SITE = new Messages("site");
	public static final Messages CALENDAR = new Messages("calendar");
	public static final Messages EXAMINE = new Messages("examine");
	public static final Messages FARM = new Messages("farm");
	public static final Messages GRAZE = new Messages("graze");
	public static final Messages HARVEST = new Messages("harvest");
	public static final Messages PLAN = new Messages("plan");
	public static final Messages GRAZINGPLAN = new Messages("grazingplan");
	public static final Messages POPULATION = new Messages("population");
	public static final Messages RELEASE = new Messages("release");
	public static final Messages UNMANAGE = new Messages("unmanage");
	public static final Messages WOOD = new Messages("wood");
	public static final Messages LANDREQUEST = new Messages("landrequest");

	
	private final String message;
	
	private Messages ( String msg )
	{
		this.message = msg;
		
	}
	
	public String toString ()
	{
		return message.toUpperCase();
		
	}
}