package PenaguilaALv4;

import java.util.Random;
import java.util.ArrayList;
import java.util.Enumeration;

public class OHTest {
	private OrderedHashtable OHash = null;
	
	public OHTest () {
		this.OHash = new OrderedHashtable();
		
	}
	
	public void run () {
		statusTest();
		putTest();
		getTest();
		remove3Test();
		remove4Test();
		putRandomTest();
		
		System.out.println("Clearing ordered hashtable...\n");
		this.OHash.clear();
		statusTest();
		containsTest();
		
		putRandomTest();
		getTest();
		remove4Test();
		getTest();
		getByTest();
		putRandomTest();
		getByTest();
		
		exceptionTest();
		
		System.out.println("Printing keys...");
		Enumeration keys = this.OHash.keys();
		
		while (keys.hasMoreElements()) {
			System.out.print((String)keys.nextElement() + "  ");
		}
		System.out.println();
		System.out.println("\nPrinting values...");
		Enumeration values = this.OHash.elements();
		
		while (values.hasMoreElements()) {
			System.out.print((String)values.nextElement() + "  ");
		}
		
		System.out.println();
		System.out.println("Printing sorted keys...");
		Enumeration skeys = this.OHash.keysInOrder();
		
		while (skeys.hasMoreElements()) {
			System.out.print((String)skeys.nextElement() + "  ");
		}
		System.out.println();
		System.out.println("\nPrinting sorted values...");
		Enumeration svalues = this.OHash.elementsInOrder();
		
		while (svalues.hasMoreElements()) {
			System.out.print((String)svalues.nextElement() + "  ");
		}
		
		System.out.println();
		System.out.println("\nPrinting ordered hashtable as a string...");
		System.out.println(this.OHash.toString());
		
		this.OHash.clear();
		
		System.out.println();
		System.out.println("\nPrinting ordered hashtable as a string...");
		System.out.println(this.OHash.toString());
		
		System.out.println("Clearing ordered hashtable...\n");
		this.OHash.clear();
		statusTest();
		containsTest();
		
		putTest();
		putTest();
		putRandomTest();
	}
	
	private void statusTest () {
		System.out.println("__ Status Test __");
		
		System.out.println("\tCurrent size: " + this.OHash.size());
		System.out.println("\tIs Empty? " + this.OHash.isEmpty());
		
		System.out.println("__ done __\n");
	
	}
	
	private void putTest () {
		Float sort_value = null;
		String hash_key = null;
		String hash_value = null;
		
		System.out.println("__ Put Test __");
		for ( float num = 0.0f; num < 6.0f; num++ ) {
			sort_value = new Float(num);
			hash_key = new String("key" + num);
			hash_value = new String(num + " in a hash");
			this.OHash.put(sort_value, hash_key, hash_value);
			System.out.println("\tPUT sort value: " + sort_value.toString() + ", hash key: " + hash_key + ", hash_value: " + hash_value);
		}
		
		System.out.println("__ done __\n");
		
		statusTest();
		containsTest();
		
	}
	
	private void putRandomTest ()
	{
		Double sort_value = null;
		String hash_key = null;
		String hash_value = null;
		int num_entries = 9;
		long seed = 3;
		Random rand = new Random(seed);
		ArrayList<Double> entries = new ArrayList<Double>();
		
		for (double num = 0.0; num < num_entries; num++) {
			entries.add(new Double(num));
		}
		
		for (int e = 0; e < num_entries; e++) {
			Double entry = entries.remove(e);
			int new_index = rand.nextInt(entries.size());
			entries.add(new_index, entry);
		}
		
		System.out.println("__ Put Random Test __");
		
		for ( int e = 0; e < num_entries; e++) {
			sort_value = entries.get(e);
			hash_key = new String("key" + sort_value.toString());
			hash_value = new String(sort_value.toString() + " in a hash");
			this.OHash.put(sort_value, hash_key, hash_value);
			System.out.println("\tPUT sort value: " + sort_value.toString() + ", hash key: " + hash_key + ", hash_value: " + hash_value);
		}
		
		System.out.println("__ done __\n");
		
		statusTest();
		containsTest();
		
	}
	
	private void getTest () {
		System.out.println("__ Get Test __");
		
		System.out.println("\tGetting min, max, and median sort values...");
		System.out.println((this.OHash.getLowestSortValue()).toString());
		System.out.println((this.OHash.getHighestSortValue()).toString());
		System.out.println((this.OHash.getMedianSortValue()).toString());
		
		System.out.println("\tGetting min, max, and median hash values...");
		System.out.println("'" + (this.OHash.getLowest()).toString() + "'");
		System.out.println("'" + (this.OHash.getHighest()).toString() + "'");
		System.out.println("'" + (this.OHash.getMedian()).toString() + "'");
		
		System.out.println("__ done __\n");
		
	}
	
	private void remove3Test () {
		System.out.println("__ Remove(value, key) Test __");
		
		Float sort_value = new Float(3.0f);
		String hash_key = new String("key" + 3.0f);
		Object hash_value = this.OHash.remove(sort_value, hash_key);
		System.out.println("\tDeleted hash value: " + hash_value.toString());
		
		System.out.println("__ done __\n");
		
		statusTest();
		containsTest();
		
	}
	
	private void remove4Test () {
		System.out.println("__ Remove(key) Test __");
		
		String hash_key = new String("key" + 4.0f);
		Object hash_value = this.OHash.remove(hash_key);
		System.out.println("\tDeleted hash value: " + hash_value.toString());
		
		System.out.println("__ done __\n");
		
		statusTest();
		containsTest();
		
	}
	
	private void containsTest () {
		Float sort_value = new Float(3.0f);
		String hash_key = new String("key" + 4.0f);
		String hash_value = new String(4.0f + " in a hash");
		Float sort_value2 = new Float(-2.0f);
		String hash_key2 = new String("numz" + 4.0f);
		String hash_value2 = new String(2.0f + " in a bush");
		System.out.println("__ Contains Test __");
		
		System.out.println("\tContains sort value '" + sort_value.toString() + "'?: " + this.OHash.containsSortValue(sort_value));
		System.out.println("\tContains hash key '" + hash_key + "'?: " + this.OHash.containsHashKey(hash_key));
		System.out.println("\tContains hash value '" + hash_value + "'?: " + this.OHash.containsHashValue(hash_value));
		System.out.println("\tContains sort value '" + sort_value2.toString() + "'?: " + this.OHash.containsSortValue(sort_value2));
		System.out.println("\tContains hash key '" + hash_key2 + "'?: " + this.OHash.containsHashKey(hash_key2));
		System.out.println("\tContains hash value '" + hash_value2 + "'?: " + this.OHash.containsHashValue(hash_value2));
		
		System.out.println("__ done __\n");

	}
	
	private void getByTest () {
		String hash_key = new String("key" + 6.0);
		int hash_index  = 2;
		Double sort_value = new Double(6.0);
		
		System.out.println("__ Get By... Test __");

		System.out.println("\tGet By Hash Key, " + hash_key.toString() + ": '" + (this.OHash.getByHashKey(hash_key)).toString() + "'");
		System.out.println("\tGet By Index, " + hash_index + ": '" + (this.OHash.getByIndex(hash_index)).toString() + "'");
		
		Object[] ret_value = this.OHash.getBySortValue(sort_value);
		System.out.println("\tGet By Sort Value, " + sort_value.toString() + " returned " + ret_value.length + " value(s):");
		for (int v = 0; v < ret_value.length; v++) {
			System.out.println("\t\t'" + (ret_value[v]).toString() + "'");
		}
		
		System.out.println("__ done __\n");
	}
	
	private void exceptionTest () {
		System.out.println("__ Exception Test __");
		
		try {
			System.out.print("\t\tcontainsHashKey(null)...");
			this.OHash.containsHashKey(null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tcontainsHashKey(String)...");
			this.OHash.containsHashKey(new String("test"));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tcontainsHashValue(null)...");
			this.OHash.containsHashValue(null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tcontainsHashValue(String)...");
			this.OHash.containsHashValue(new String("test"));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tcontainsSortValue(null)...");
			this.OHash.containsSortValue(null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tcontainsSortValue(Double)...");
			this.OHash.containsSortValue(new Double(-10.0));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tgetByHashKey(null)...");
			this.OHash.getByHashKey(null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tgetByHashKey(String)...");
			this.OHash.getByHashKey(new String("test"));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tgetByIndex(-2)...");
			this.OHash.getByIndex(-2);
		}
		
		catch (IndexOutOfBoundsException ioobe) {
			System.out.print("caught IndexOutOfBoundsException.");
		}
		
		finally {
			System.out.println();
		}	
		
		try {
			System.out.print("\t\tgetByIndex(100)...");
			this.OHash.getByIndex(100);
		}
		
		catch (IndexOutOfBoundsException ioobe) {
			System.out.print("caught IndexOutOfBoundsException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tgetBySortValue(null)...");
			this.OHash.getBySortValue(null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tgetBySortValue(Double)...");
			this.OHash.getBySortValue(new Double(-10.0));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tput(null, String, String)...");
			this.OHash.put(null, new String("key"), new String("value"));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tput(Double, null, String)...");
			this.OHash.put(new Double(1.0), null, new String("value"));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tput(Double, String, null)...");
			this.OHash.put(new Double(1.0), new String("key"), null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tremove(null)...");
			this.OHash.remove(null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tremove(null, String)...");
			this.OHash.remove(null, new String("key"));
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tremove(Double, null)...");
			this.OHash.remove(new Double(1.0), null);
		}
		
		catch (NullPointerException npe) {
			System.out.print("caught NullPointerException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tremove(Double, String)...");
			this.OHash.remove(new Double(2.0), new String("test"));
		}
		
		catch (IllegalArgumentException iae) {
			System.out.print("caught IllegalArgumentException.");
		}
		
		finally {
			System.out.println();
		}
		
		try {
			System.out.print("\t\tremove(Double, String)...");
			this.OHash.remove(new Double(-2.0), new String("key" + 2.0));
		}
		
		catch (IllegalArgumentException iae) {
			System.out.print("caught IllegalArgumentException.");
		}
		
		finally {
			System.out.println();
		}
		
		System.out.println("__ done __\n");
		
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		OHTest test = new OHTest();
		test.run();
	}

}
