/*
 * TypeAgents.java
 *
 * Package Version: 3.0
 *   Class Version: 1.0
 *   
 * Author: Gary R. Mayer
 *   Date: 28 June 2007
 * 
 * This class provides an enumeration for all agent types used in the simulation. 
 * 
 * NOTE: This implementation is NOT remote method invocation (RMI) safe
 * 	nor will it work if different objects are created using multiple jar files.
 * 
 * Class Fixes / Additions:
 * 1.0:
 *  - None.
 * 
 * Bugs / Issues:
 * 1.0:
 *  - None.
 */

package PenaguilaALv4;

public final class TypeAgents
{	
	/////////////////////////////////////
	//          AGENT TYPES            //
	/////////////////////////////////////
	public static final TypeAgents VILLAGE = new TypeAgents("village");
	public static final TypeAgents HOUSEHOLD = new TypeAgents("household");
	// add any additional agent types here
	
	private final String agent;
	
	
	private TypeAgents ( String agent )
	{
		this.agent = agent;
		
	}
	
	/**
	 * toString() - returns a string representation of the agent object
	 * @return - String (agent) 
	 */
	public String toString ()
	{
		return agent.toUpperCase();
		
	}
	
}
