/*     
 *    
 *  Author     : ACIMS(Arizona Centre for Integrative Modeling & Simulation)
 *  Version    : DEVSJAVA 2.7 
 *  Date       : 08-15-02 
 */
package SimpArcMod;


import java.awt.*;
import java.io.*;

import GenCol.*;


import model.modeling.*;
import model.simulation.*;

import view.modeling.ViewableAtomic;
import view.modeling.ViewableComponent;
import view.modeling.ViewableDigraph;
import view.simView.*;



public class ef extends ViewableDigraph{


public ef(){
    super("ef");
    efConstruct(10,500);
}

public ef(String nm,double int_arr_t,double observe_t){
    super(nm);
    efConstruct(int_arr_t,observe_t);
}

public void efConstruct(double int_arr_t,double observe_t){

    addInport("in");
    addOutport("out");
    addOutport("result");

    ViewableAtomic g = new genr("g",int_arr_t);
    ViewableAtomic t = new transd("t",observe_t);

     add(g);
     add(t);

     addTestInput("start",new entity());
     addTestInput("stop",new entity());
     addTestInput("in",new entity("job0"));
     addTestInput("in",new entity("job1"));

     initialize();


     addCoupling(g,"out",t,"ariv");
     addCoupling(this,"in",t,"solved");
     addCoupling(t,"out",g,"stop");
     addCoupling(this,"start",g,"start");
     addCoupling(this,"stop",g,"stop");
     addCoupling(g,"out",this,"out");
     addCoupling(t,"out",this,"result");

    preferredSize = new Dimension(279, 146);
    g.setPreferredLocation(new Point(6, 17));
    t.setPreferredLocation(new Point(-5, 81));
}


    /**
     * Automatically generated by the SimView program.
     * Do not edit this manually, as such changes will get overwritten.
     */
    public void layoutForSimView()
    {
        preferredSize = new Dimension(497, 127);
        ((ViewableComponent)withName("g")).setPreferredLocation(new Point(220, 28));
        ((ViewableComponent)withName("t")).setPreferredLocation(new Point(-4, 63));
    }
}
