/*     
 *    
 *  Author     : ACIMS(Arizona Centre for Integrative Modeling & Simulation)
 *  Version    : DEVSJAVA 2.7 
 *  Date       : 08-15-02 
 */

package SimpArcMod;

import java.awt.*;
import java.util.*;

import GenCol.*;


import model.modeling.*;
import model.simulation.*;

import view.modeling.ViewableComponent;
import view.modeling.ViewableDigraph;
import view.simView.*;



public class multiServer extends ViewableDigraph{



public multiServer() {this("multiserver", 2, 2);}

public multiServer(String name,double proc_time,int size)
{
 super(name);
 make(proc_time,size);
 addTestInput("in", new entity("job"));
}


 private void make(double proc_time,int size){

    addInport("in");
    addOutport("out");

    multiServerCoord  co  = new multiServerCoord("MultiSco");
   add(co);

 for (int i = 1; i <= size; i++){
     proc  p = new procName("processor_" + i, proc_time);
    add(p);
   co.add_procs(p);
    p.setPreferredLocation(new Point(187, 22 + 80 * (i - 1)));

  }

    Iterator i = getComponents().iterator();
    while (i.hasNext()) {
       entity ent = (entity)i.next();
       devs comp = (devs)ent;
   if (!ent.equals(co))
  {
    addCoupling(co, "y", comp,"inName"); //use name for routing
    addCoupling(comp,"outName",co,"x");
  }

  }
    addCoupling(this,"in",co,"in");
    addCoupling(co,"out",this,"out");


initialize();

    preferredSize = new Dimension(508, 32 + 80 * size);
    co.setPreferredLocation(new Point(-7, 20));
}

    /**
     * Automatically generated by the SimView program.
     * Do not edit this manually, as such changes will get overwritten.
     */
    public void layoutForSimView()
    {
        preferredSize = new Dimension(500, 252);
        ((ViewableComponent)withName("processor_3")).setPreferredLocation(new Point(201, 103));
        ((ViewableComponent)withName("MultiSco")).setPreferredLocation(new Point(-7, 20));
        ((ViewableComponent)withName("processor_1")).setPreferredLocation(new Point(187, 22));
        ((ViewableComponent)withName("processor_4")).setPreferredLocation(new Point(148, 179));
        ((ViewableComponent)withName("processor_2")).setPreferredLocation(new Point(-4, 105));
    }
}
